#!/usr/bin/perl

##!perl
##!/usr/bin/perl

use utf8;
use Encode;
use CGI;
use URI::Escape;
use HTML::Entities;
use HTML::Template;

## 設定
# ファイルの保存先
$savepath = "data/note/";

# テンプレート指定
$result_filename = "template/post/result.html";

# テンプレートの定義
my $result;
open (RESULT, "<:utf8", $result_filename) or die "Couldn't open template file: $!\n";
$result = HTML::Template->new( filehandle => *RESULT, 'die_on_bad_params' => 0 );
close(RESULT);

# POSTされたデータの受け取り
$postData = new CGI;
$postData->charset("utf-8");

$mode = $postData->param('mode');

if ($mode eq '1') {
	# POSTされたデータの受け取り
	$name = $postData->param('name');
	$comment = $postData->param('comment');

	# UTF-8フラグON
	$name = Encode::decode_utf8($name);
	$comment = Encode::decode_utf8($comment);

	# 改行コードの変換
	$comment =~ s/\x0D\x0A|\x0D|\x0A/\n/g;

	# バイナリモード ON
	binmode(STDOUT, ":utf8");	

	# POSTされたデータの書き込み先を指定
	$time = time();
	$commentfile = $savepath . $time . ".txt";

	# 固定文字列設定
	$fixed_name = "投稿者: ";

	# コメントファイルへ書き込み
	open(comment, ">:utf8", $commentfile ) || die "Can't create $commentfile: $!";
	binmode(comment, ":utf8");

	print comment $fixed_name, $name;
	print comment "\n";
	print comment $comment;

	close(comment);

	# HTML出力を実行
	print qq|Content-type: text/html\n\n|;
	print $result->output;

}

1;

