#!/usr/bin/perl

##!perl
##!/usr/bin/perl

use utf8;
use Encode;
use CGI;
use URI::Escape;
use HTML::Entities;
use HTML::Template;


## 設定ここから ##

# タイトル
$title = "第586回ホワイティ杯ポケモン小説コンテスト - 夏の終わりに -";

# ファイルの保存先
$savepath = "data/post/";

# テンプレート指定
$input_filename = "template/post/input.html";
$revise_filename = "template/post/revise.html";
$confirm_filename = "template/post/confirm.html";
$result_filename = "template/post/result.html";
$htmltemplate_filename = "template/post/output/htmltemplate.html";

## 設定ここまで ##


# 入力画面のテンプレート呼び出し
open (INPUT, "<:utf8", $input_filename) or die "Couldn't open template file: $!\n";
$input = HTML::Template->new( filehandle => *INPUT, 'die_on_bad_params' => 0 );
close(INPUT);

# 修正画面のテンプレート呼び出し
open (REVISE, "<:utf8", $revise_filename) or die "Couldn't open template file: $!\n";
$revise = HTML::Template->new( filehandle => *REVISE, 'die_on_bad_params' => 0 );
close(REVISE);

# 確認画面のテンプレート呼び出し
open (CONFIRM, "<:utf8", $confirm_filename) or die "Couldn't open template file: $!\n";
$confirm = HTML::Template->new( filehandle => *CONFIRM, 'die_on_bad_params' => 0 );
close(CONFIRM);

# 結果画面のテンプレート呼び出し
open (RESULT, "<:utf8", $result_filename) or die "Couldn't open template file: $!\n";
$result = HTML::Template->new( filehandle => *RESULT, 'die_on_bad_params' => 0 );
close(RESULT);

# 出力ファイルのテンプレート呼び出し
open (HTMLTEMPLATE, "<:utf8", $htmltemplate_filename) or die "Couldn't open template file: $!\n";
$htmltemplate = HTML::Template->new( filehandle => *HTMLTEMPLATE, 'die_on_bad_params' => 0 );
close(HTMLTEMPLATE);

# postDataの定義
$postData = new CGI;
$postData->charset("utf-8");

# POSTされたデータの受け取り
$realname = $postData->param('realname');
$maskname = $postData->param('maskname');
$rating = $postData->param('rating');
$document = $postData->param('document');
$documentDisp = $postData->param('documentDisp');
$mode = $postData->param('mode');
$return = $postData->param('return');

# 投稿時はチェックボックスは配列で渡されるため、一旦取得した後分解
# ただし確認→保存時は値で渡されてくるのでそのまま取得
if ($mode eq '1') {
	@updateList = $postData->param('update');
	$update = @updateList[0];
} elsif ($mode eq '2') {
	$update = $postData->param('update');
}

# UTF-8フラグON
$title = Encode::decode_utf8($title);
$realname = Encode::decode_utf8($realname);
$maskname = Encode::decode_utf8($maskname);
$rating = Encode::decode_utf8($rating);
$document = Encode::decode_utf8($document);
$documentDisp = Encode::decode_utf8($documentDisp);

# 改行コードの変換
$document =~ s/\x0D\x0A|\x0D|\x0A/\n/g;
$documentDisp =~ s/\x0D\x0A|\x0D|\x0A/\n/g;

# 文字列は常にUTF-8で処理
binmode(STDOUT, ":utf8");

# メインルーチン
#
# mode == '' and return == '' の場合
# 	・空の入力ページを表示
# 	・ページの表示に $input_filename で指定したHTMLファイルを使用する
#
# mode == '' and return != '' の場合
# 	・値を引き継いだ入力ページを表示
# 	・ページの表示に $revise_filename で指定したHTMLファイルを使用する
#
# mode == '1' の場合
# 	・入力内容の確認ページを表示
# 	・ページの表示に $confirm_filename で指定したHTMLファイルを使用する
#
# mode == '2' の場合
# 	・ファイルへの書き込みを行った後、投稿完了ページを表示
# 	・ページの表示には $result_filename で指定したHTMLファイルを使用する
# 	・作成するHTMLファイルのひな形には $htmltemplate_filename で指定したHTMLファイルを使用する

if($mode eq '') {
	# 画面表示用パラメータの設定
	$input->param(title => $title);

	# HTML出力を実行
	print qq|Content-type: text/html\n\n|;
	print $input->output;

} elsif($return ne '') {
	# 画面表示用パラメータの設定
	$revise->param(title => $title);
	$revise->param(realname => $realname);
	$revise->param(maskname => $maskname);
	$revise->param(document => $document);
	
	# レーティングは選択状態により分岐
	if ($rating eq 'Normal') {
		$revise->param(rating_setected_1 => "selected=\"selected\"");
	} else {
		$revise->param(rating_setected_1 => "");
	}
	if ($rating eq 'R-18') {
		$revise->param(rating_setected_2 => "selected=\"selected\"");
	} else {
		$revise->param(rating_setected_2 => "");
	}
	if ($rating eq 'R-18G') {
		$revise->param(rating_setected_3 => "selected=\"selected\"");
	} else {
		$revise->param(rating_setected_3 => "");
	}

	# 更新フラグは選択状態により分岐
	if ($update eq '1') {
		$revise->param(update => "checked=\"checked\"");
	} else {
		$revise->param(update => "");
	}

	# HTML出力を実行
	print qq|Content-type: text/html\n\n|;
	print $revise->output;

} elsif ($mode eq '1') {
	# この画面で使用するデータはすべてエンティティ化
	$realname = encode_entities($realname, q{&<>"'});
	$maskname = encode_entities($maskname, q{&<>"'});
	$rating = encode_entities($rating, q{&<>"'});
	$update = encode_entities($update, q{&<>"'});
	$document = encode_entities($document, q{&<>"'});
	$documentDisp = $document;

	# 表示用処理（変数 DocumentDisp の置換処理）
	$documentDisp =~ s/^/<p>/mg;
	$documentDisp =~ s/$/<\/p>/mg;
	$documentDisp =~ s/<p><\/p>/<p><br><\/p>/mg;

	# 更新フラグから表示文字列を指定
	if ($update eq '1') {
		$updateDisp = "投稿済み作品の差し替え";
	} else {
		$updateDisp = "初回投稿";
	}	

	# 画面表示用パラメータの設定
	$confirm->param(realname => $realname);
	$confirm->param(maskname => $maskname);
	$confirm->param(rating => $rating);
	$confirm->param(update => $update);
	$confirm->param(updateDisp => $updateDisp);
	$confirm->param(document => $document);
	$confirm->param(documentDisp => $documentDisp);

	# HTML出力を実行
	print qq|Content-type: text/html\n\n|;
	print $confirm->output;

} elsif ($mode eq '2') { 
	# 書き込む前にエンティティをデコード
	$realname = decode_entities($realname, q{&<>"'});
	$maskname = decode_entities($maskname, q{&<>"'});
	$rating = decode_entities($rating, q{&<>"'});
	$update = decode_entities($update, q{&<>"'});
	$document = decode_entities($document, q{&<>"'});

	# 以下の処理は廃止
	# 投稿者名をURIエンコードし、%を除去
	# $maskname_uri = uri_escape_utf8($maskname);
	# $maskname_uri =~ s/%//g;
	
	# アップデートの場合ファイル名にそれを記載
	if ($update eq '1') {
		$update = "_update";
	} else {
		$update = "";
	}

	# POSTされたデータの書き込み
	$time = time();
	$documentfile = $savepath . $time . $update . "_document.txt";
	$authorfile = $savepath . $time . $update . "_author.txt";
	$htmlfile = $savepath . $time . $update . ".html";

	# 固定文字列設定
	$fixed_author = "Author: ";
	$fixed_rating = "Rating: ";
	$fixed_maskname = "Maskname: ";
	$fixed_realname = "Realname: ";

	# 作品ファイルへ書き込み
	open(DOCUMENT, ">:utf8", $documentfile ) || die "Can't create $documentfile: $!";
	binmode(DOCUMENT, ":utf8");

	print DOCUMENT $fixed_author, $maskname;
	print DOCUMENT "\n";
	print DOCUMENT $fixed_rating, $rating;
	print DOCUMENT "\n\n";
	print DOCUMENT $document;
	print DOCUMENT "\n";

	close(DOCUMENT);

	# 作者情報ファイルへ書き込み
	open(AUTHOR, ">:utf8", $authorfile ) || die "Can't create $authorfile: $!";
	binmode(AUTHOR, ":utf8");

	print AUTHOR $fixed_maskname, $maskname;
	print AUTHOR "\n";
	print AUTHOR $fixed_realname, $realname;
	print AUTHOR "\n";

	close(AUTHOR);

	# HTMLファイルへ書き込み
	open(HTMLFILE, ">:utf8", $htmlfile ) || die "Can't create $htmlfile: $!";
	binmode(HTMLFILE, ":utf8");

	$htmltemplate->param(maskname => $maskname);
	$htmltemplate->param(rating => $rating);
	$htmltemplate->param(document => $documentDisp);
	print $htmltemplate->output(print_to => *HTMLFILE);

	close(HTMLFILE);

	# HTML出力を実行
	print qq|Content-type: text/html\n\n|;
	print $result->output;

}

1;

