#!/usr/bin/perl

##!perl
##!/usr/bin/perl

use utf8;
use Encode;
use CGI;
use URI::Escape;
use HTML::Entities;
use HTML::Template;


## 設定ここから ##

# タイトル
$title = "第586回ホワイティ杯ポケモン小説コンテスト - 夏の終わりに -";

# ファイルの保存先
$savepath = "data/vote/";

# テンプレート指定
$input_filename = "template/vote/input.html";
$revise_filename = "template/vote/revise.html";
$confirm_filename = "template/vote/confirm.html";
$result_filename = "template/vote/result.html";

## 設定ここまで ##


# 入力画面のテンプレート呼び出し
open (INPUT, "<:utf8", $input_filename) or die "Couldn't open template file: $!\n";
$input = HTML::Template->new( filehandle => *INPUT, 'die_on_bad_params' => 0 );
close(INPUT);

# 修正画面のテンプレート呼び出し
open (REVISE, "<:utf8", $revise_filename) or die "Couldn't open template file: $!\n";
$revise = HTML::Template->new( filehandle => *REVISE, 'die_on_bad_params' => 0 );
close(REVISE);

# 確認画面のテンプレート呼び出し
open (CONFIRM, "<:utf8", $confirm_filename) or die "Couldn't open template file: $!\n";
$confirm = HTML::Template->new( filehandle => *CONFIRM, 'die_on_bad_params' => 0 );
close(CONFIRM);

# 結果画面のテンプレート呼び出し
open (RESULT, "<:utf8", $result_filename) or die "Couldn't open template file: $!\n";
$result = HTML::Template->new( filehandle => *RESULT, 'die_on_bad_params' => 0 );
close(RESULT);

# 投稿作品リストのロード処理
$listfile = "template/vote/list.txt";

# CSVファイルを開く
open(LISTFILE, "<:utf8", $listfile) or die "Cannot open $listfile for read: $!";

while ($line = <LISTFILE>) {
	# 改行を取り除く
	chomp $line; 

	@temp = split(',', $line);
	$item = {
		name => $temp[0],
		url => $temp[1],
		rating => $temp[2]
	};

	push(@candidates, $item); 
}

close(LISTFILE);

# 作品数
$candidate_length = @candidates;

# POSTされたデータの受け取り
$postData = new CGI;
$postData->charset("utf-8");

# UTF-8フラグ ON
$title = Encode::decode_utf8($title);

$mode = $postData->param('mode');
$name = $postData->param('name');
$anonymous = $postData->param('anonymous');
$return = $postData->param('return');

for($i = 0; $i < $candidate_length; $i++) {
	$point[$i] = $postData->param('point'. $i);
	$comment[$i] = $postData->param('comment'. $i);

	# UTF-8フラグ ON 
	$point[$i] = Encode::decode_utf8($point[$i]);
	$comment[$i] = Encode::decode_utf8($comment[$i]);

	# 改行コードの変換
	$comment[$i] =~ s/\x0D\x0A|\x0D|\x0A/\n/g;
}

# バイナリモード ON
binmode(STDOUT, ":utf8");

if($mode eq '') {
	# 画面表示パラメータの設定
	for($i = 0; $i < $candidate_length; $i++) {
		$candidates[$i]->{num} = $i;
		if (($candidates[$i]->{rating} eq 'R-18') or ($candidates[$i]->{rating} eq 'R-18G')) {
			$candidates[$i]->{skip} = "<input type=\"radio\" name=\"point$i\" id=\"point$i\" value=\"0\" onchange=\"isReadonly($i)\">投票をスキップする";
		}
	}

	$input->param(candidates => \@candidates);
	$input->param(title => $title);

	# HTML出力を実行
	print qq|Content-type: text/html\n\n|;
	print $input->output;

} elsif($return ne '') {
	# この画面で使用するデータはすべてエンティティ化解除
	$name = decode_entities($name, q{&<>"'});
	$anonymous = decode_entities($anonymous, q{&<>"'});

	# UTF-8フラグ ON
	$name = Encode::decode_utf8($name);
	$anonymous = Encode::decode_utf8($anonymous);

	# 画面表示パラメータの設定
	for($i = 0; $i < $candidate_length; $i++) {
		$point[$i] = decode_entities($point[$i], q{&<>"'});
		$comment[$i] = decode_entities($comment[$i], q{&<>"'});

		if (($candidates[$i]->{rating} eq 'R-18') or ($candidates[$i]->{rating} eq 'R-18G')) {
			$candidates[$i]->{skip} = "<input type=\"radio\" name=\"point$i\" id=\"point$i\" value=\"0\" onchange=\"isReadonly($i)\">投票をスキップする";
			if ($point[$i] eq '0') {
				$candidates[$i]->{skip} = "<input type=\"radio\" name=\"point$i\" id=\"point$i\" value=\"0\" checked=\"checked\" onchange=\"isReadonly($i)\">投票をスキップする";
			}
		}

		if ($point[$i] eq '1') {
			$candidates[$i]->{point_checked_1} = "checked=\"checked\"";
		}
		if ($point[$i] eq '2') {
			$candidates[$i]->{point_checked_2} = "checked=\"checked\"";
		}
		if ($point[$i] eq '3') {
			$candidates[$i]->{point_checked_3} = "checked=\"checked\"";
		}
		if ($point[$i] eq '9') {
			$candidates[$i]->{point_checked_9} = "checked=\"checked\"";
		}

		$candidates[$i]->{point} = $point[$i];
		$candidates[$i]->{comment} = $comment[$i];
		$candidates[$i]->{num} = $i;
	}

	$revise->param( votename => $name);
	if ($anonymous eq '1') {
		$revise->param ( anonymous => "checked=\"checked\"" )
	} else {
		$revise->param ( anonymous => "" )
	}
	$revise->param(candidates => \@candidates);
	$revise->param(title => $title);

	# HTML出力を実行
	print qq|Content-type: text/html\n\n|;
	print $revise->output;

} elsif ($mode eq '1') {
	# この画面で使用するデータはすべてエンティティ化
	$name = encode_entities($name, q{&<>"'});
	$anonymous = encode_entities($anonymous, q{&<>"'});

	# UTF-8フラグ ON
	$name = Encode::decode_utf8($name);
	$anonymous = Encode::decode_utf8($anonymous);

	# 画面表示パラメータの設定
	for($i = 0; $i < $candidate_length; $i++) {
		$point[$i] = encode_entities($point[$i], q{&<>"'});
		$comment[$i] = encode_entities($comment[$i], q{&<>"'});

		# コメント表示用
		$commentDisp[$i] = Encode::decode_utf8($comment[$i]);
		$commentDisp[$i] =~ s/\n/<br>\n/g;

		if($commentDisp[$i] eq '') {
			$commentDisp[$i] = "(コメント無し)";
		}
		
		# ポイント表示用
		if ($point[$i] eq '0') {
			$pointDisp[$i] = Encode::decode_utf8("投票をスキップする");
		} elsif ($point[$i] eq '1') {
			$pointDisp[$i] = Encode::decode_utf8("☆");
		} elsif ($point[$i] eq '2') {
			$pointDisp[$i] = Encode::decode_utf8("☆☆");
		} elsif ($point[$i] eq '3') {
			$pointDisp[$i] = Encode::decode_utf8("☆☆☆");
		} elsif ($point[$i] eq '9') {
			$pointDisp[$i] = Encode::decode_utf8("この作品は自作品です");
		}

		$candidates[$i]->{point} = $point[$i];
		$candidates[$i]->{pointDisp} = $pointDisp[$i];
		$candidates[$i]->{comment} = $comment[$i];
		$candidates[$i]->{commentDisp} = $commentDisp[$i];
		$candidates[$i]->{num} = $i;
	}

	$confirm->param( votename => $name);
	$confirm->param( anonymous => $anonymous);

	if ($anonymous eq '1') {
		$confirm->param ( anonymousDisp => Encode::decode_utf8("（匿名で投票する）") );
	} else {
		$confirm->param ( anonymousDisp => Encode::decode_utf8("") );
	}

	$confirm->param(candidates => \@candidates);

	# HTML出力を実行
	print qq|Content-type: text/html\n\n|;
	print $confirm->output;

} elsif ($mode eq '2') { 
	# この画面で使用するデータはすべてエンティティ化解除
	$name = decode_entities($name, q{&<>"'});
	$anonymous = decode_entities($anonymous, q{&<>"'});

	# UTF-8フラグ ON
	$name = Encode::decode_utf8($name);
	$anonymous = Encode::decode_utf8($name);

	for($i = 0; $i < $candidate_length; $i++) {
		$point[$i] = decode_entities($point[$i], q{&<>"'});
		$comment[$i] = decode_entities($comment[$i], q{&<>"'});

		# コメント保存用（改行を<br>に置換）
		$commentDisp[$i] = $comment[$i];
		$commentDisp[$i] =~ s/\n/<br>/g;
		
		# コメントが無い場合固定コメントを設定
		if($commentDisp[$i] eq '') {
			$commentDisp[$i] = "(コメント無し)";
		}
	}
	
	# 匿名希望の場合ファイル名にそれを記載
	if ($anonymous eq '1') {
		$anonymous = "_anon";
	} else {
		$anonymous = "";
	}

	# POSTされたデータの書き込み
	$time = time();
	$pointfile = $savepath . "point_" . $time . $anonymous . ".txt";
	$commentfile = $savepath . "comment_" . $time . $anonymous . ".txt";

	# ポイントファイルへ書き込み
	open(POINT, ">:utf8", $pointfile ) || die "Can't create $pointfile: $!";
	binmode(POINT, ":utf8");
	print POINT $name, "\t";

	for($i = 0; $i < $candidate_length; $i++) {
		print POINT $point[$i], "\t";
	}

	close(POINT);

	# コメントファイルへ書き込み
	open(COMMENT, ">:utf8", $commentfile ) || die "Can't create $commentfile: $!";
	binmode(COMMENT, ":utf8");
	print COMMENT $name,"\t";

	for($i = 0; $i < $candidate_length; $i++) {
		print COMMENT $commentDisp[$i], "\t";
	}

	close(COMMENT);

	# HTML出力を実行
	print qq|Content-type: text/html\n\n|;
	print $result->output;
}

1;


